/* Sierpinski Gasket in GLUT, gkf 3jan2K */ 
#include <stdlib.h>
#include <stdio.h>
#include <gl/glut.h>
#include <math.h>
float v[3][2] = {{1.,0.},{0.,1.},{0.,0.}};    /* a triangle */
float vv[2]={.2,.9};                          /* initial pos'n */
#define RND ((float)rand()/RAND_MAX)         /* random fraction */
#define INT(X) ((int)floor(X))                 /* integer part */
/***********************************************************/
void display(){       
  int ii = INT(3*(RND));        /* pick random ii = 0,1,2 */
  vv[0]= (vv[0] + v[ii][0])/2;  /* move half-way toward that vertex */
  vv[1]= (vv[1] + v[ii][1])/2;  

  glBegin(GL_POINTS);                 /* draw   */              
    glColor3f(1.0,1.0,1.0);           /* white  */
    glVertex2fv(vv);                  /* point  */ 
  glEnd(); 
}
/***********************************************************/
void keyboard(unsigned char key, int x, int y){
  switch(key){ 
     case  27: fprintf(stderr," Thanks for using GLUT ! \n"); exit(0); break;
     case 'w': {glClear(GL_COLOR_BUFFER_BIT);   /* wipe screen */
                glClearColor(0.,0.,0.,0.);    
                break;}; 
   }
}
/***********************************************************/
void idle(void){ glutPostRedisplay(); } 
/***********************************************************/
int main(int argc, char **argv){ 
  glutInitWindowSize(400, 400);        
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB); 
  glutCreateWindow("<< Sierpinski in GLUT >>");
  glutDisplayFunc(display);
  glutKeyboardFunc(keyboard);
  glutIdleFunc(idle); 
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-2.0,2.0,-2.0,2.0,-2.0,2.0);
  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  glutMainLoop();
  return 0;             /* ANSI C requires main to return int. */
}
